package com.fp.persistence.pcustomer.balance;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;
import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TCUSTBALANCE*/
@Entity(name="TcustBalance")
@Table(name="TCUSTBALANCE")
public class TcustBalance extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TcustBalance
*/
@EmbeddedId
private TcustBalanceKey pk;
/**Contructor por defecto*/
public TcustBalance(){
}
/**Contructor de TcustBalance
@param pPk Clave Primaria del entity
*/
public TcustBalance(TcustBalanceKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TcustBalance
*/
public static TcustBalance find(EntityManager pEntityManager,TcustBalanceKey pKey) throws Exception{
    TcustBalance obj = pEntityManager.find(TcustBalance.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TcustBalance
@return El objeto que referencia a la Clave primaria de TcustBalance
*/
public TcustBalanceKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TcustBalance
@param pPk El objeto que referencia a la nueva Clave primaria de TcustBalance
*/
public void setPk(TcustBalanceKey pPk){
  pk=pPk;
}
public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TcustBalance))return false;
    TcustBalance that = (TcustBalance) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TcustBalance
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TcustBalance
*/
public Object createInstance(){
 TcustBalance instance=new TcustBalance();	
 instance.setPk(new TcustBalanceKey());
 return instance;
}
/**Clona la entidad TcustBalance
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TcustBalance p=(TcustBalance)this.clone();
  p.setPk((TcustBalanceKey)this.pk.cloneMe());
  return p;
}
}
